SystemOrganization addCategory: #'OpenDBX-Core-Structure'!
SystemOrganization addCategory: #'OpenDBX-Core-API'!
SystemOrganization addCategory: #'OpenDBX-Core-Tests'!
SystemOrganization addCategory: #'OpenDBX-Core-Tests-Backup'!
SystemOrganization addCategory: #'OpenDBX-Core-Description'!
SystemOrganization addCategory: #'OpenDBX-Core-Benchmark'!

!False methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:55'!
asDbxString
	^'0'! !

Notification subclass: #DBXNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!String class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:11'!
fromDbxString: aString
	^aString! !

!String methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:20'!
asDbxString
	^String new writeStream
		nextPut: $';
		nextPutAll: self;
		nextPut: $';
		contents! !

ExternalStructure subclass: #DBXTimeSpec
	instanceVariableNames: 'seconds nseconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'EL 3/30/2008 15:19'!
fields
	^#(
		(seconds	'long')
		(nseconds	'long'))! !

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'EL 3/30/2008 15:36'!
seconds: seconds
	^(self new)
		seconds: seconds;
		nseconds: 0;
		yourself.! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'EL 3/30/2008 15:18'!
nseconds
	^ nseconds! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'EL 3/30/2008 15:18'!
nseconds: anObject
	nseconds := anObject! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'EL 3/30/2008 15:18'!
seconds
	^ seconds! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'EL 3/30/2008 15:18'!
seconds: anObject
	seconds := anObject! !

!Time class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:36'!
fromDbxString: aString 
	^ self readDbxFrom: aString readStream! !

!Time class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:11'!
readDbxFrom: aStream
	| hour minute second |

	hour := (aStream upTo: $:) asInteger.
	minute := (aStream upTo: $:) asInteger.
	second := (aStream upToEnd) asInteger.

	^self hour: hour  
		minute: minute 
		second:  second! !

!Time methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:24'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.	
	^ stream contents asDbxString! !

!Time methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:24'!
printDbxOn: aStream
	aStream
		nextPutAll: (self hour asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self minutes asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self seconds asString padded: #left to: 2 with: $0).
! !

!DateAndTime class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 11:29'!
fromDbxString: aString 
	^self readDbxFrom: aString readStream! !

!DateAndTime class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 11:30'!
readDbxFrom: aStream
	| year month day hour minute second |

	year := (aStream upTo: $-) asInteger.
	month := (aStream upTo: $-) asInteger.
	day := (aStream upTo: Character space) asInteger.
	hour := (aStream upTo: $:) asInteger.
	minute := (aStream upTo: $:) asInteger.
	second := (aStream upToEnd) asInteger.
	
	^ self
		year: year
		month: month
		day: day
		hour: hour
		minute: minute
		second: second.! !

!DateAndTime methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:29'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents asDbxString! !

!DateAndTime methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:30'!
printDbxOn: aStream
	aStream
		nextPutAll: self year asString;
		nextPut: $-;
		nextPutAll: (self monthIndex asString padded: #left to: 2 with: $0);
		nextPut: $-;
		nextPutAll: (self dayOfMonth asString padded: #left to: 2 with: $0);
		nextPut: Character space;	
		nextPutAll: (self hour asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self minutes asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self seconds asString padded: #left to: 2 with: $0).
! !

TestCase subclass: #DBXBaseFunctionalityTest
	instanceVariableNames: 'facility'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXBaseFunctionalityTest methodsFor: 'accessing' stamp: 'MMP 6/3/2008 22:19'!
facility
	^ facility! !

!DBXBaseFunctionalityTest methodsFor: 'accessing' stamp: 'MMP 6/3/2008 22:19'!
facility: anObject
	facility := anObject! !

DBXBaseFunctionalityTest subclass: #DBXConnectionTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXConnectionTest3 methodsFor: 'as yet unclassified' stamp: 'MMP 6/3/2008 22:21'!
testBlah
	Transcript show: 'Mariano groso!!!!!!'.! !

TestCase subclass: #DBXBaseTest
	instanceVariableNames: 'facility connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:59'!
doConnect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.	
	conn connect.
	^conn! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:55'!
doConnectAndOpen
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.
	conn connect.
	conn open.
	^ conn! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 5/22/2008 00:15'!
doDisconnect: aConnection 
	aConnection disconnect.! !

!DBXBaseTest methodsFor: 'running' stamp: 'HMC 8/4/2008 18:36'!
dropScript: aConnection 
	"Here we catch the errors because the first time the tests are run, if you didn't create the tables by hand before, you will have an error here (because de table doesn't exist') and it won't continue to the create statements."
	[ aConnection execute: 'DROP TABLE curso;' ] 
		on: DBXError
		do: 
			[ :e | 
			Transcript show: e.
			e printOn: Transcript ].
	[ aConnection execute: 'DROP TABLE materia;' ] 
		on: Error
		do: [ :e | Transcript show: e ].
	[ aConnection execute: 'DROP TABLE alumno;' ] 
		on: Error
		do: [ :e | Transcript show: e ]! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
facility
	^ facility! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
facility: anObject
	facility := anObject! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
platform
	^ facility platform! !

!DBXBaseTest methodsFor: 'running' stamp: 'HMC 8/4/2008 18:37'!
runDDLSetUpScript: aConnection 
	"The database structure is the same for all tests and most of them will need to have the structure generated. So, this method do exactly that,"
	"Here we catch the errors because the first time the tests are run, if you didn't create the tables by hand before, you will have an error here (because de table doesn't exist') and it won't continue to the create statements."
	self dropScript: aConnection.
	"Now I create all tables, fks, indexes, and so on."

	aConnection execute: 'CREATE TABLE alumno(
	   id INTEGER,
	   nombre_apellido TEXT,	   
	   regular BOOLEAN,
	   edad SMALLINT,	   
	   promedio DECIMAL(9,3),
	   sexo CHARACTER(3),
	   descripcion TEXT,
	   hora_ingreso TIME,
	   fecha_alta TIMESTAMP,
	   fecha_nacimiento DATE,
	  CONSTRAINT pk_alumnos_id PRIMARY KEY (id)
	);'.
	aConnection execute: 'CREATE TABLE materia(
	codigo INTEGER, 
	nombre CHAR(35),
	observaciones VARCHAR(255),
	CONSTRAINT pk_materias_codigo PRIMARY KEY (codigo)
);'.
	aConnection execute: 'CREATE TABLE curso(
	id_curso INTEGER,
	id_alumno INTEGER,
	codigo_materia INTEGER,
	Fecha_inicio DATE,
	CONSTRAINT pk_cursos_id_curso PRIMARY KEY (id_alumno, codigo_materia)
);'.
	aConnection execute: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id);'.
	aConnection execute: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES materia(codigo);'! !

!DBXBaseTest methodsFor: 'running' stamp: 'HMC 8/4/2008 18:40'!
runDDLTearDownScript: aConnection
self dropScript: aConnection.! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 7/9/2008 02:20'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	self subclassResponsibility! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 7/18/2008 21:50'!
setUp
	"The setUp of this DBXBaseTest lets the database clear to tests. It runs the
	DDL and the common DML script for testing. Then each subclass should
	inserter, delete or whatever it need"
	super setUp.
	"this sould be done from outside"
	facility := DBXBackendFacility postgresFacility.
	connection := self doConnectAndOpen.
	self runDDLSetUpScript: connection.
	self runDMLSetUpScript: connection! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'EL 7/1/2008 15:19'!
settings
	^ facility connectionSettings! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 7/10/2008 00:43'!
tearDown
	"This method run a DDL script to free results and close the connection used in the setUp and in here"
	super tearDown.
	self runDDLTearDownScript: connection.
	self doDisconnect: connection.
	connection := nil.! !

DBXBaseTest subclass: #DBXCompleteExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXCompleteExamplesTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 21:31'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXCompleteExamplesTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 22:24'!
testACompleteExample
	| conn connectionSettings result result2 |
	connectionSettings := DBXConnectionSettings
				host: 'localhost'
				port: '5432'
				database: 'sodbxtest'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest'.
	conn := DBXConnection platform: DBXPostgresPlatform new settings: connectionSettings.
	conn connect.
	conn open.
	result := conn execute: 'select * from materia'.
	DBXTranscript show: result.
	conn execute: 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (59, ''TADP'', ''Tecnicas Av'') '.
	conn execute: 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (60, ''APIT'', ''ARQUITECTURA DE PROYECTOS DE IT'') '.
	result := conn execute: 'select * from materia'.
	DBXTranscript show: result.
	result := conn execute: 'delete from materia where nombre = ''TADP'''.
	DBXTranscript show: result.
	result2 := conn execute: 'select * from materia'.
	DBXTranscript show: result2.
	result := conn execute: 'update materia set observaciones = ''something'' where codigo = 60'.
	DBXTranscript show: result.
	result2 := conn execute: 'select * from materia'.
	DBXTranscript show: result2.
	conn close.
	conn disconnect! !

DBXBaseTest subclass: #DBXConnectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:56'!
doConnectAndDisconnect
	| conn |
	conn := self doConnectAndOpen.
	conn disconnect.
	^conn! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 6/17/2008 22:56'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:55'!
testCloseIncorrect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.

	"I have not do a open so this should rise an error"
	self 
		should: [ conn close ]
		raise: DBXError.
	"The same if i Try to do a query"
	self 
		should: [ conn execute: 'SELECT * from alumno where id = 1' ]
		raise: DBXError.
	conn := self doConnectAndOpen.
	"The first time should work well"
	conn close.
	"now, as I have already done a close, this shoud rise an error"
	self 
		should: [ conn close ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'EL 7/1/2008 15:24'!
testCloseWithoutOpen
	| conn |
	conn := DBXConnection 
				platform: self platform
				settings: self settings.	
	self should: [ conn close ] raise: DBXError.! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:55'!
testConnectAndOpen
	| conn |
	conn := self doConnectAndOpen.
	conn disconnect.
	^ conn! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 19:12'!
testConnectIncorrect
	| conn |
	conn := self doConnectAndOpen.

	"As I have already done a connect: it should raise an error"
	self 
		should: [ conn connect ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:39'!
testConnectOpenCloseOpen
	| conn  |
	conn := self doConnectAndOpen.
	self assert: conn isOpen.
	conn close.
	self assert: conn isOpen not.
	conn open.
	self assert: conn isOpen.
	conn close.
	conn disconnect.
	! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:55'!
testDisconnectIncorrect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.

	"I have not do a connect first so this should rise an error"
	self 
		should: [ conn disconnect ]
		raise: DBXError.
	conn := self doConnectAndOpen.
	"The first time should work well"
	conn disconnect.
	"now, as I have already done a disconnect, this shoud rise an error"
	self 
		should: [ conn disconnect ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'EL 7/1/2008 15:26'!
testDisconnectWithoutConnect
	| conn | 
	conn := DBXConnection 
				platform: self platform
				settings: self settings.	
		
	self should: [ conn disconnect ] raise: DBXError.
	! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/11/2008 02:02'!
testGCDisconnection
	"I have to call garbageCollect because maybe there are previous
	connections that are inconsistence or maybe they just have references
	and because of this the GC doesn't clean them. We assume there aren't
	created new connections at the same time of running the test from
	elsewhere"
	| connectionInstancesSizeBeforeTest weakRegistrySizeBeforeTest |
	1
		to: 3
		do: [:i | Smalltalk garbageCollect].
	connectionInstancesSizeBeforeTest := DBXConnection allInstances size.
	weakRegistrySizeBeforeTest := (WeakRegistry default keys
				select: [:each | each class = DBXConnection]) size.
	self doConnectAndOpen.
	1
		to: 3
		do: [:i | Smalltalk garbageCollect].
	self assert: DBXConnection allInstances size = connectionInstancesSizeBeforeTest.
	self assert: (WeakRegistry default keys
			select: [:each | each class = DBXConnection]) size > 0! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/10/2008 00:51'!
testInvalidInputData
	| conn settings |
	
	"If the port is invalid, I should have an error during open"
	settings := self facility connectionSettings.
	settings port: '1'.
	"If I put localhost instead of 127.0.0.1 it works"
	settings host: '127.0.0.1'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.
	

	"If the ip is invalid, I should have an error during open"
	"IMPORTANT: This test run well but it takes to much time because of the time out. It is commented
	settings := self facility connectionSettings.
	settings host: '192.45.67.8'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError."
	

	"If the database is invalid, I should have an error during open"
	settings := self facility connectionSettings.
	settings database: 'noExist'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.



	"If the username is invalid, I should have an error during open"
	settings := self facility connectionSettings.
	settings userName: 'noExist'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.
	

	"If the user password is invalid, I should have an error during open"
	settings := self facility connectionSettings.
	settings userPassword: 'noExist'.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.
	

	"If the authentication method is invalid, I should have an error during open"
	settings := self facility connectionSettings.
	"Just right now, method must be ZERO"
	settings method: 1.
	conn := DBXConnection platform: self platform settings: settings.
	conn connect.
	self should: [conn open] raise: DBXError.

! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 6/17/2008 22:12'!
testManualAndGCDisconnection

	"I have to call garbageCollect because maybe there are previous connections that are inconsistence or maybe they 	just have references and because of this the GC doesn't clean them. We assume there aren't created new connections 	at the same time of running the test from elsewhere "
	
	| connectionInstancesSizeBeforeTest |
	1 to: 3 do: [ :i | Smalltalk garbageCollect ].
	connectionInstancesSizeBeforeTest := DBXConnection allInstances size.
		
	self doConnectAndDisconnect.
	1 to: 3 do: [ :i | Smalltalk garbageCollect ].
	self assert: DBXConnection allInstances size = connectionInstancesSizeBeforeTest.! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:33'!
testManualDisconnection
	| conn conn2 |
	conn := self doConnect.
	conn disconnect.
	conn2 := self doConnectAndOpen.
	conn2 close.
	conn2 disconnect! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 19:12'!
testOpenIncorrect
	| conn |
	conn := self doConnectAndOpen.

	"as I have already open the connection this should rise a DBXError"
	self 
		should: [ conn open ]
		raise: DBXError.
	self 
		should: [ conn open ]
		raise: DBXError.
	self 
		should: [ conn open ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:57'!
testShutDownAndStartUp
	| conn  |
	conn := self doConnectAndOpen.
	self assert: conn isOpen.
	conn shutDown.
	self assert: conn isOpen not.
	conn startUp.
	self assert: conn isOpen not.
! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/8/2008 20:59'!
testShutDownDisconnection
	| conn  |
	conn := self doConnectAndOpen.
	conn shutDown.
	self assert: conn isOpen not
! !

!DBXConnectionTest methodsFor: 'as yet unclassified' stamp: 'MMP 4/25/2008 02:01'!
testShutDownManualDisconnection
	| conn  |
	conn := self doConnectAndDisconnect.
	self assert: conn isOpen not.
	conn shutDown.
	self assert: conn isOpen not
! !

DBXBaseTest subclass: #DBXDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 19:17'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 19:19'!
testGetColumnDescription
	| conn select result aRow |
	
	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	self 
		should: [ result description columnDescriptionAt: 6 ]
		raise: Error.
	self 
		shouldnt: [ result description columnDescriptionAt: 1 ]
		raise: Error.
	self 
		shouldnt: [ result description columnDescriptionAt: 2 ]
		raise: Error.
	self assert: (result description columnDescriptionAt: 1) name = 'codigo'.
	aRow := result nextRow.
	self assert: aRow isNil.
	
	select := 'SELECT codigo FROM materia'.
	result := conn execute: select.
	self 
		should: [ result description columnDescriptionAt: 2 ]
		raise: Error.
	self 
		shouldnt: [ result description columnDescriptionAt: 1 ]
		raise: Error.
	self assert: (result description columnDescriptionAt: 1) name = 'codigo'.
	aRow := result nextRow.
	self assert: aRow isNil.
	
	conn close.
	conn disconnect! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 19:23'!
testGetColumnDescriptionWithName
	| conn select result aRow |
	conn := self doConnectAndOpen.
	select := 'SELECT codigo FROM materia'.
	result := conn execute: select.
	self
		should: [result columnDescriptionWithName: 'noexist']
		raise: DBXError.
	self
		should: [result columnDescriptionWithName: 'nombre']
		raise: DBXError.
	self
		shouldnt: [result columnDescriptionWithName: 'codigo']
		raise: DBXError.
	aRow := result nextRow.
	self assert: aRow isNil.
	conn close.
	conn disconnect! !

DBXBaseTest subclass: #DBXOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:16'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/12/2008 02:51'!
testCompression
	| conn result |
	conn := self doConnect.
	result := conn enableCompression.
	result ifTrue: 
		[ conn open.
		Transcript show: 'Compression supported'; cr.
		self 
			shouldnt: (conn execute: 'select * from alumno;')
			raise: Error ].
	result ifFalse: 
		[ conn open.
		Transcript show: 'Compression doesnt supported'; cr.
		self 
			shouldnt: (conn execute: 'select * from alumno;')
			raise: Error ].
	conn close.
	conn disconnect! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/12/2008 02:51'!
testEncryption
	| conn result |
	conn := self doConnect.
	result := conn enableEncryption.
	result ifTrue: 
		[ conn open.
		Transcript show: 'Encryption supported'; cr.
		self 
			shouldnt: (conn execute: 'select * from alumno;')
			raise: Error ].
	result ifFalse: 
		[ conn open.
		Transcript show: 'Encryption doesnt supported'; cr.
		self 
			shouldnt: (conn execute: 'select * from alumno;')
			raise: Error ].
	conn close.
	conn disconnect! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/12/2008 02:31'!
testGetOption
	| conn isSupported |
	conn := self doConnect.
	isSupported := conn isOptionSupportedByPlattform: DBXSpecialOptions multipleStatements.
	conn open.
	conn close.
	conn disconnect! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/12/2008 02:51'!
testMultipleStatments
	| conn result |
	conn := self doConnect.
	result := conn enableMultipleStatements.
	result ifTrue: 
		[ conn open.
		Transcript show: 'MultipleStatments supported'; cr.
		self 
			shouldnt: (conn execute: 'select * from alumno; select * from alumno;')
			raise: Error ].
	result ifFalse: 
		[ conn open.
		Transcript show: 'MultipleStatments doesnt supported'; cr.
		self 
			should: (conn execute: 'select * from alumno; select * from alumno;')
			raise: Error ].
	conn close.
	conn disconnect! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/12/2008 02:57'!
testPagedResults
	| conn result select aRow |
	conn := self doConnect.
	result := conn enablePagedResults.
	result
		ifTrue: [conn open.
			Transcript show: 'PagedResults supported';
				 cr.
			select := 'SELECT * FROM curso'.
			result := conn execute: select.
			aRow := result nextRow.
			self assert: aRow isNil].
	result
		ifFalse: [conn open.
			Transcript show: 'PagedResults doesnt supported';
				 cr.
			self
				shouldnt: (conn execute: 'select * from alumno;')
				raise: Error].
	conn close.
	conn disconnect! !

DBXBaseTest subclass: #DBXQueryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXQueryTest methodsFor: 'running' stamp: 'HMC 8/4/2008 22:28'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (1, ''aStudent'', 23) '.
	result := conn execute: insert.
	insert := 'INSERT INTO alumno (id, nombre_apellido, edad) VALUES (2, ''anotherStudent'', 24) '.
	result := conn execute: insert.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 15:41'!
testCloseBeforeQuery
	| conn select |
	conn := self doConnectAndOpen.
	conn close.
	select := 'SELECT * FROM materia'.
	self
		should: [conn execute: select]
		raise: DBXError.
	conn disconnect! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 8/4/2008 17:00'!
testCloseResultsByClosingConnection
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.
	conn finalize.
	self deny: result isOpen.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'EL 7/26/2008 12:53'!
testCorrectResult
| conn select result aRow delete update insert drop |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM materia'.
	result := conn execute: select.
	self should: [ result class = DBXResultSet ].
	aRow := result nextRow.	
	self assert: aRow isNil.
	delete := 'delete from materia'.
	result := conn execute: delete.
	self should: [ result class = DBXResult ].
	update := 'update materia set nombre = ''XXX'' '.
	result := conn execute: update.
	self should: [ result class = DBXResult ].
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	result := conn execute: insert.
	self should: [ result class = DBXResult ].
	drop := 'drop table materia cascade'.
	result := conn execute: drop.
	self should: [ result class = DBXResult ].! !

!DBXQueryTest methodsFor: 'deleteTests' stamp: 'HMC 8/4/2008 22:26'!
testDelete
	| conn result delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	self assert: result rowsAffected isNonZero.! !

!DBXQueryTest methodsFor: 'deleteTests' stamp: 'HMC 8/4/2008 22:29'!
testDeleteFollowedByAnotherDelete
	| conn aResult anotherResult aDelete anotherDelete |
	conn := self doConnectAndOpen.
	aDelete  := 'delete from alumno where id = 1'.
	anotherDelete  := 'delete from alumno where id = 2'.
	aResult := conn execute: aDelete.
	self shouldnt: [ anotherResult := conn execute: anotherDelete ] raise: DBXError.
	self assert: aResult rowsAffected isNonZero.
	self assert: anotherResult rowsAffected isNonZero.! !

!DBXQueryTest methodsFor: 'deleteTests' stamp: 'HMC 8/4/2008 22:30'!
testDeleteIsClosedAfterExecute
	| conn result delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	self deny: result isOpen.! !

!DBXQueryTest methodsFor: 'deleteTests' stamp: 'HMC 8/4/2008 22:31'!
testDeleteWithBadData
	| conn delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno where id = should be numeric'.
	self should: [ conn execute: delete  ] raise: DBXError.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 15:43'!
testDisconnectBeforeQuery
	| conn select |
	conn := self doConnectAndOpen.
	conn disconnect.
	select := 'SELECT * FROM materia'.
	self
		should: [conn execute: select]
		raise: DBXError.! !

!DBXQueryTest methodsFor: 'deleteTests' stamp: 'HMC 8/4/2008 22:26'!
testDuplicateDelete
	| conn result delete |
	conn := self doConnectAndOpen.
	delete := 'delete from alumno'.
	result := conn execute: delete.
	self shouldnt: [ conn execute: delete ] raise: DBXError.! !

!DBXQueryTest methodsFor: 'insertTests' stamp: 'HMC 8/4/2008 19:11'!
testDuplicateInsert
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	result := conn execute: insert.
	self should: [ conn execute: insert ] raise: DBXError.! !

!DBXQueryTest methodsFor: 'updateTests' stamp: 'HMC 8/4/2008 20:37'!
testDuplicateUpdate
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	self shouldnt: [ conn execute: update ] raise: DBXError.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'MMP 7/9/2008 01:32'!
testEmptyResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia where codigo = 99999'.
	result := conn execute: select.	
	aRow := result nextRow.	
	self assert: aRow isNil.
	result finalize.
	conn finalize.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 12:25'!
testEmptyResultSetRows
	| conn result select rows |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM curso'.
	result := conn execute: select.	
	rows := result nextRow.	
	self assert: rows isNil.
	result finalize.
	conn finalize.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 15:32'!
testFinalizeAfterDisconnectResultSet
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn disconnect.
	self shouldnt: [ result finalize ] raise: DBXError.
	
	! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 14:44'!
testFinalizeTwiceResultSet
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.
	result finalize.
	self shouldnt: [ result finalize  ] raise: DBXError.	
	conn finalize.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 15:47'!
testHasRowsEmptyResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia where codigo = 99999'.
	result := conn execute: select.	
	aRow := result nextRow.	
	self deny: result hasRows.
	result finalize.
	conn finalize.! !

!DBXQueryTest methodsFor: 'insertTests' stamp: 'HMC 8/4/2008 19:09'!
testInsert
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	result := conn execute: insert.
	self assert: result rowsAffected isNonZero.! !

!DBXQueryTest methodsFor: 'insertTests' stamp: 'HMC 8/4/2008 19:11'!
testInsertFollowedByAnotherInsert
	| conn aResult anotherResult AnInsert anotherInsert |
	conn := self doConnectAndOpen.
	AnInsert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	anotherInsert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (56,''TADP2'',''Nothing'')'.
	aResult := conn execute: AnInsert.
	self shouldnt: [ anotherResult := conn execute: anotherInsert ] raise: DBXError.
	self assert: aResult rowsAffected isNonZero.
	self assert: anotherResult rowsAffected isNonZero.! !

!DBXQueryTest methodsFor: 'insertTests' stamp: 'HMC 8/4/2008 22:17'!
testInsertIsClosedAfterExecute
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES (55, ''TADP'', ''Nothing'') '.
	result := conn execute: insert.
	self deny: result isOpen.! !

!DBXQueryTest methodsFor: 'insertTests' stamp: 'HMC 8/4/2008 21:01'!
testInsertWithBadData
	| conn insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO materia(codigo, nombre, observaciones) VALUES ("should be numeric", 1, 1) '.
	self should: [ conn execute: insert  ] raise: DBXError.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 11:20'!
testIterateResultSet
	| conn   |
	conn := self doConnectAndOpen.
	"to be done when there's data on the DB'"
	self assert: true.
	conn finalize.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'MMP 7/12/2008 01:17'!
testNextRowAfterCloseResultSet
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn close.
"	self shouldnt: [ result nextRow ] raise: DBXError."
	conn disconnect.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 11:20'!
testNextRowAfterDisconnect
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn disconnect.
	
	"I have closed de connection, so this should rise an error"	
	self should: [ result nextRow ] raise: DBXError.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 11:20'!
testNextRowAfterFinalizeResultSet
	| conn select result |

	select := 'SELECT * FROM materia'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	result finalize.
	
	"I have closed de resultSet, so this should rise an error"	
	self should: [ result nextRow ] raise: DBXError.
	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 8/4/2008 16:49'!
testQueryFollowedByAnotherQuery
	| conn aRresult select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM curso'.
	aRresult := conn execute: select.
	self should: [ conn execute: select. ] raise: DBXError.
	conn finalize.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 11:59'!
testSelect
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM materia'.
	result := conn execute: select.
	"DBXTranscript show: result.	"
	self shouldnt: [ result nextRow ] raise: DBXError.
	result finalize.
	conn finalize.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 12:15'!
testSingleQuery
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM curso'.
	result := conn execute: select.	
	aRow := result nextRow.	
	self assert: aRow isNil.
	result finalize.
	conn finalize.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 8/4/2008 18:50'!
testTwoQueries
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM curso'.
	result := conn execute: select.	
	aRow := result nextRow.	
	self assert: aRow isNil.
	result finalize.
	result := conn execute: select.	
	aRow := result nextRow.	
	self assert: aRow isNil.
	result finalize.
	conn finalize.! !

!DBXQueryTest methodsFor: 'updateTests' stamp: 'HMC 8/4/2008 20:36'!
testUpdate
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	self assert: result rowsAffected isNonZero.! !

!DBXQueryTest methodsFor: 'updateTests' stamp: 'HMC 8/4/2008 22:21'!
testUpdateFollowedByAnotherUpdate
	| conn aResult anotherResult anUpdate anotherUpdate |
	conn := self doConnectAndOpen.
	anUpdate := 'update alumno set edad = ''25'' '.
	anotherUpdate := 'update alumno set edad = ''23'' '.
	aResult := conn execute: anUpdate.
	self shouldnt: [ anotherResult := conn execute: anotherUpdate ] raise: DBXError.
	self assert: aResult rowsAffected isNonZero.
	self assert: anotherResult rowsAffected isNonZero.! !

!DBXQueryTest methodsFor: 'updateTests' stamp: 'HMC 8/4/2008 22:17'!
testUpdateIsClosedAfterExecute
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''25'' '.
	result := conn execute: update.
	self deny: result isOpen.! !

!DBXQueryTest methodsFor: 'updateTests' stamp: 'HMC 8/4/2008 21:02'!
testUpdateWithBadData
	| conn update |
	conn := self doConnectAndOpen.
	update := 'update alumno set edad = ''should be numeric'' '.
	self should: [ conn execute: update  ] raise: DBXError.! !

!DBXQueryTest methodsFor: 'queryTests' stamp: 'HMC 7/11/2008 15:48'!
testWrongSQL
	| conn select |
	conn := self doConnectAndOpen.
	select:= 'THIS IS NOT VALID SQL'.
	self should: [ conn execute: select. ] raise: DBXError.
	conn finalize.! !

DBXBaseTest subclass: #DBXTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXTypeTest methodsFor: 'running' stamp: 'EL 8/2/2008 12:27'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/2/2008 12:53'!
testBoolean
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		conn execute: '
			DROP TABLE IF EXISTS test_boolean_columns;
			CREATE TABLE test_boolean_columns (
				bool_boolean 	BOOLEAN);
					
			INSERT INTO test_boolean_columns
				(bool_boolean)
				VALUES (true);' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_boolean_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'bool_boolean').
		
	conn close.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/2/2008 12:44'!
testCharacter
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		conn execute: '
			DROP TABLE IF EXISTS test_character_columns;
			CREATE TABLE test_character_columns (
				char_char		CHAR(10),
				char_varchar	VARCHAR(10));
					
			INSERT INTO test_character_columns
				(char_char, char_varchar)
				VALUES (''test'', ''test'');' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_character_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'char_char') = 
		('test' padded: #right to: 10 with: Character space).
	self assert: (row valueNamed: 'char_varchar') = 'test'.
		
	conn close.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/2/2008 12:50'!
testDatetime
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		conn execute: '
			DROP TABLE IF EXISTS test_datetime_columns;
			CREATE TABLE test_datetime_columns (
				datetime_date 			DATE,
				datetime_time 			TIME,
				datetime_timestamp 	TIMESTAMP);
					
			INSERT INTO test_datetime_columns
				(datetime_date, datetime_time, datetime_timestamp)
				VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_datetime_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'datetime_date') = (Date year: 2008 month: 1 day: 20).
	self assert: (row valueNamed: 'datetime_time') = (Time hour: 10 minute: 20 second: 30).
	self assert: (row valueNamed: 'datetime_timestamp') = 
		(TimeStamp 
			year: 2008 
			month: 1 
			day: 20 
			hour: 10 
			minute: 20 
			second: 30).
		
	conn close.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/2/2008 12:40'!
testNumeric
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		conn execute: '
			DROP TABLE IF EXISTS test_numeric_columns;
			CREATE TABLE test_numeric_columns (
				number_decimal 	DECIMAL(5,2),
				number_real 		REAL,
				number_float 		FLOAT,
				number_smallint 	SMALLINT,
				number_integer 		INTEGER);
					
			INSERT INTO test_numeric_columns
				(number_decimal, number_real, number_float, number_smallint, number_integer)
				VALUES (42.2, 42.2, 42.2, 42, 42);' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_numeric_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'number_decimal') = 42.2.
	self assert: (row valueNamed: 'number_real') = 42.2.
	self assert: (row valueNamed: 'number_float') = 42.2.
	self assert: (row valueNamed: 'number_smallint') = 42.
	self assert: (row valueNamed: 'number_integer') = 42.
		
	conn close.! !

TestCase subclass: #DBXConnectionSettingsTest
	instanceVariableNames: 'facility connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXConnectionSettingsTest methodsFor: 'tests' stamp: 'MMP 7/10/2008 23:30'!
testValidateMethod
	"The method is distinct to zero"
	| settings |
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 5.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: -5.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 'nothing'.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 0.
	self
		shouldnt: [settings validateMethod]
		raise: DBXError! !

!DBXConnectionSettingsTest methodsFor: 'tests' stamp: 'MMP 7/10/2008 23:30'!
testValidatePort
	| settings |
	
	"The port is negative but must be positive"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '-1'. 
	self should: [ settings validatePort ] raise: DBXError.
	
	"The port is zero but must be positive"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '0'. 
	self shouldnt: [settings validatePort] raise: DBXError.
	
	"The not a number but must be positive number"
	settings := DBXConnectionSettings host: '123.4.7.2' port: 'invalidPort'. 
	self should: [ settings validatePort ] raise: DBXError.
	
	"The port is correct"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '88'. 
	self shouldnt: [settings validatePort] raise: DBXError.
		
! !

TestCase subclass: #DBXMainTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXMainTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:13'!
testMySQL
	| |

"	connectionTest := DBXConnectionTest new.
	connectionTest facility: DBXBackendFacility mySQLFacility.
	connectionTest run.
"	
		
		Transcript show: DBXConnectionTest suite run.
"		Transcript show: DBXOptionsTest suite run."
		"xxxx"
		
	"connectionTest := DBXConnectionTest new.
	connectionTest facility: DBXBackendFacilityHelper postgresFacility.
	connectionTest run.
	"
	
	"testRunner classSelected: connect|ionTest.
	testRunner runAll. 
	""
		testRunner := TestRunner new.
	testRunner runSuite: DBXConnectionTest suite"
	"		(DBXConnectionTest selector: #testCloseWithoutOpen) 
	
	(testRunner selector: #testCloseIncorrect) run.
	"
! !

!DBXMainTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:13'!
testPostgres
	| |
		
		Transcript show: DBXConnectionTest suite run.
"		Transcript show: DBXOptionsTest suite run."
		"xxxx"
		
	"connectionTest := DBXConnectionTest new.
	connectionTest facility: DBXBackendFacility postgresFacility.
	connectionTest run.
	"
	"testRunner classSelected: connect|ionTest.
	testRunner runAll. 
	""
		testRunner := TestRunner new.
	testRunner runSuite: DBXConnectionTest suite"
	"		(DBXConnectionTest selector: #testCloseWithoutOpen) 
	
	(testRunner selector: #testCloseIncorrect) run.
	"
! !

TestCase subclass: #DBXMainTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMainTest3 methodsFor: 'tests' stamp: 'MMP 6/3/2008 21:57'!
testMySql! !

!DBXMainTest3 methodsFor: 'tests' stamp: 'MMP 6/3/2008 21:57'!
testOracle! !

!DBXMainTest3 methodsFor: 'tests' stamp: 'MMP 6/17/2008 22:45'!
testPostgresql
	| testRunner connectionTest |
	testRunner := TestRunner new.
	connectionTest := DBXConnectionTest3 new.
	connectionTest facility: DBXPostgresqlFacility new.
	testRunner runTest: connectionTest! !

Object subclass: #DBXAuthenticationMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXAuthenticationMethod class methodsFor: 'methods' stamp: 'MMP 7/10/2008 23:20'!
usernamePassword
	^0.! !

Object subclass: #DBXBackendFacility
	instanceVariableNames: 'platform connectionSettings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Backup'!

!DBXBackendFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 7/11/2008 15:50'!
mySQLFacility
	| facility connectionSettings |
	facility := DBXBackendFacility new.
	connectionSettings := DBXConnectionSettings
				host: 'localhost'
				port: '3306'
				database: 'sodbxtest'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest'.
	facility connectionSettings: connectionSettings.
	facility platform: DBXMySQLPlatform new.
	^ facility! !

!DBXBackendFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 7/11/2008 15:50'!
postgresFacility
	^DBXBackendFacility new
		platform: DBXPostgresPlatform new;
		connectionSettings: (DBXConnectionSettings 
			host: 'localhost' 
			port: '5432' 
			database: 'sodbxtest' 
			userName: 'sodbxtest' 
			userPassword: 'sodbxtest');
		yourself.
! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
connectionSettings
	^ connectionSettings! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
connectionSettings: anObject
	connectionSettings := anObject! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
platform
	^ platform! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
platform: anObject
	platform := anObject! !

Object subclass: #DBXBaseFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

DBXBaseFacility subclass: #DBXPostgresqlFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

Object subclass: #DBXBenchmark
	instanceVariableNames: 'times facility'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXBenchmark class methodsFor: 'defaults' stamp: 'EL 7/2/2008 11:57'!
defaultFacility
	^DBXBackendFacility postgresFacility ! !

!DBXBenchmark class methodsFor: 'defaults' stamp: 'EL 7/1/2008 21:31'!
defaultRuns
	^10! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:25'!
collect: aBlock
	self runs timesRepeat: [
		times add: (MessageTally time: aBlock)	]! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:18'!
collectedTimeAverage
	^((times inject: 0 into: [ :v :each | v + each ]) / self class defaultRuns) asFloat! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/2/2008 11:57'!
facility
	^facility ifNil: [ facility := self class defaultFacility ]! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/2/2008 11:57'!
facility: aFacility
	facility := aFacility! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:32'!
findBenchmarks
	^self class allSelectors asSortedCollection asOrderedCollection select: [:each | 
		('benchmark*' match: each) and: [each numArgs isZero]]! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/1/2008 21:58'!
log: aString
	Transcript show: aString; cr.! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:18'!
prepareCollector
	times := OrderedCollection new.
	! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/2/2008 11:55'!
run: aSelector
	self prepareCollector.
	self setUp.
	self collect: [ self perform: aSelector ].
	self tearDown.
	self log: aSelector, ': ', self collectedTimeAverage asString, ' AVG'.
	! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/1/2008 21:59'!
runAll
	self log: 'Benchmarking: ', self class name, ' (', self runs asString, ' runs)'.
	self findBenchmarks do: [ :each | 
		self run: each ] ! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/1/2008 21:31'!
runs
	^self class defaultRuns ! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/2/2008 11:55'!
setUp! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/2/2008 11:55'!
tearDown! !

DBXBenchmark subclass: #DBXTinyBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXTinyBenchmarks class methodsFor: 'defaults' stamp: 'EL 7/1/2008 21:31'!
defaultRuns
	^100! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 7/2/2008 11:56'!
benchmarkSelect
	(connection execute: 'SELECT * FROM alumno')
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 7/1/2008 21:30'!
initialize
	super initialize.
	self initializeConnection.! !

!DBXTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 7/26/2008 13:49'!
initializeConnection
	connection := DBXConnection
		platform: self facility platform
		settings: self facility connectionSettings.
	connection connect.
	connection open.
! !

DBXBenchmark subclass: #PGTinyBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!PGTinyBenchmarks class methodsFor: 'defaults' stamp: 'EL 7/1/2008 21:33'!
defaultRuns
	^100! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 7/2/2008 11:56'!
benchmarkSelect
	(connection  execute: 'SELECT * FROM alumno') lastResultSet 
		in: [ :resultSet |
			resultSet rows do: [ :each | each data ] ]  ! !

!PGTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 7/1/2008 21:33'!
initialize
	super initialize.
	self initializeConnection.! !

!PGTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 7/26/2008 13:07'!
initializeConnection
	connection := PGConnection new
		connectionArgs: (PGConnectionArgs new
			hostname: 'localhost';
			portno: 5432;
			databaseName: 'sodbxtest';
			userName: 'sodbxtest';
			password: 'sodbxtest');
		yourself.
	connection startup.
! !

Object subclass: #DBXColumnDescription
	instanceVariableNames: 'type dbxType name size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'EL 8/3/2008 08:48'!
name: aString dbxType: aNumber type: aType
	^self name: aString dbxType: aNumber type: aType size: 0! !

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'EL 8/3/2008 08:47'!
name: aNameString dbxType: aNumber type: aTypeSymbol size: aTypeSizeNumber
	^(super new)
		name: aNameString;
		type: aTypeSymbol;
		size: aTypeSizeNumber;
		yourself.! !

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'EL 3/31/2008 11:58'!
new
	self error: 'Use caption:type:'! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 8/3/2008 08:45'!
dbxType
	^ dbxType! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 8/3/2008 08:45'!
dbxType: anObject
	dbxType := anObject! !

!DBXColumnDescription methodsFor: 'testing' stamp: 'EL 8/3/2008 09:05'!
isLarge
	^DBXPlatform isLarge: self dbxType! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:49'!
name
	^name! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:49'!
name: aString
	name := aString! !

!DBXColumnDescription methodsFor: 'printing' stamp: 'EL 6/27/2008 20:45'!
printOn: aStream
	aStream nextPut: $(.
	self name printOn: aStream.
	aStream nextPut: $:.
	self type printOn: aStream.
	aStream nextPut: $).! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:49'!
size
	^size! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:50'!
size: aNumber
	size := aNumber! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 3/31/2008 11:24'!
type
	^ type! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 3/31/2008 11:24'!
type: anObject
	type := anObject! !

Object subclass: #DBXConnection
	instanceVariableNames: 'platform settings handle open connected resultSets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXConnection class methodsFor: 'initialization' stamp: 'MMP 4/15/2008 00:37'!
initialize
	"DBConnection initialize"

	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!DBXConnection class methodsFor: 'logging' stamp: 'EL 5/12/2008 18:50'!
log: message
	Transcript show: message; cr.! !

!DBXConnection class methodsFor: 'instance creation' stamp: 'EL 7/1/2008 16:51'!
platform: aPlatform settings: aConnectionSettings
	^self new
		platform: aPlatform;
		settings: aConnectionSettings;
		yourself! !

!DBXConnection class methodsFor: 'system startup' stamp: 'MMP 7/9/2008 19:49'!
shutDown
	self
		allInstancesDo: [:each | each shutDown]! !

!DBXConnection class methodsFor: 'system startup' stamp: 'EL 7/1/2008 20:52'!
startUp
	"Right now i do nothing in the startup. Perhaps in a future I should open the connections that were closed when the image was down"
"	self allInstancesDo: [ :each| each startUp ]."! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 5/12/2008 18:45'!
= aDBXConnection
	^ self handle = aDBXConnection handle.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 7/2/2008 01:36'!
close
	self isOpen ifFalse: [ 
		DBXError signal: 'Error: The connection is not open. Try opening it first.' ].
	self platform closeConnection: self.
	self internalBeClosed! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 7/10/2008 23:28'!
connect
	self isConnected
		ifTrue: [DBXError signal: 'You are already connected. Try disconnecting before'].
	self validateSettingsForConnect.
	"WARNING This is the only place where we have direct access to
	handles... "
	handle := self platform createConnection: self.
	WeakRegistry default add: self.
	self internalBeConnected! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'EL 7/1/2008 17:23'!
connectAndOpen
	"Take into consideration that using this method you cannot specify special options because 
	  many of them should be called between connect and open operations"
	self connect.
	self open.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 7/2/2008 01:37'!
disconnect
	self isConnected ifFalse: [ 
		DBXError signal: 'Error: The connection is not connected. Try connecting first.' ].
	self releaseResultSets.
	self isOpen ifTrue: [ self close ].
	self releaseConnection.
	self internalBeDisconnected.
	handle := nil! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 7/12/2008 02:33'!
enableCompression
	^self enableSpecialOption: DBXSpecialOptions compression.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 7/12/2008 02:33'!
enableEncryption
	^self enableSpecialOption: DBXSpecialOptions encryption.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 7/12/2008 01:46'!
enableMultipleStatements
	^self enableSpecialOption: DBXSpecialOptions multipleStatements! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 7/12/2008 02:33'!
enablePagedResults
	^self enableSpecialOption: DBXSpecialOptions pagedResults.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 7/12/2008 01:30'!
enableSpecialOption: specialOption 
	"It returns if the specialOption could be enable or not
	Before enabling a specific option, I must be sure the current backend
	support it"
	(self isOptionSupportedByPlattform: specialOption)
		ifTrue: [self platform
				setOption: specialOption
				value: true
				on: self.
				^true.].
		^false.
! !

!DBXConnection methodsFor: 'query' stamp: 'EL 6/29/2008 12:31'!
execute: aString
	| resultSet |
	self isOpen ifFalse: [
		DBXError signal: 'Error: You cannot execute a query if the connection is not ' ].
	resultSet := self platform executeStatement: aString on: self.
	^resultSets add: resultSet. ! !

!DBXConnection methodsFor: 'finalization' stamp: 'MMP 4/25/2008 00:45'!
finalize
	self isConnected ifTrue: [ self disconnect ]! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 3/30/2008 14:41'!
handle
	^handle! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 5/1/2008 18:37'!
hash
	^ self handle hash! !

!DBXConnection methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:43'!
initialize
	super initialize.
	open := ValueHolder new contents: false.
	connected := ValueHolder new contents: false.
	resultSets := WeakSet new.! !

!DBXConnection methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:59'!
initializePlatform: aPlatform settings: aConnectionSettings handle: aNumber
	platform := aPlatform.
	settings := aConnectionSettings.
	handle := aNumber.
	self internalBeConnected.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeClosed
	open contents: false! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeConnected
	connected contents: true.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeDisconnected
	connected contents: false.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeOpen
	open contents: true.! !

!DBXConnection methodsFor: 'testing' stamp: 'MMP 4/25/2008 00:44'!
isConnected
	^connected contents.! !

!DBXConnection methodsFor: 'testing' stamp: 'MMP 4/25/2008 00:44'!
isOpen
	^open contents.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 7/11/2008 01:52'!
isOptionSupportedByPlattform: specialOption 
	^self platform
		getOption: specialOption
		on: self.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'HMC 7/11/2008 15:37'!
open
	self isConnected ifFalse: [
		DBXError signal: 'Error: You are not connected. Try connecting first'  ].
	self isOpen ifTrue: [ 
		DBXError signal: 'Error: The connection is already open' ].
	self validateSettingsForOpen.
	self platform openConnection: self.
	self internalBeOpen! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/10/2008 01:06'!
platform
	^platform! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 7/1/2008 16:54'!
platform: aPlatform
	platform := aPlatform! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/29/2008 10:52'!
releaseConnection
	self platform releaseConnection: self! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:49'!
releaseResultSets
	resultSets 
		select: [ :each| each isOpen ] 
		thenDo: [ :each| each finalizeResultSet ]! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:42'!
settings
	^ settings! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 7/1/2008 16:54'!
settings: aConnectionSettings
	settings := aConnectionSettings! !

!DBXConnection methodsFor: 'running' stamp: 'MMP 7/9/2008 19:12'!
shutDown
	 self isConnected ifTrue: [
		self disconnect ]
! !

!DBXConnection methodsFor: 'running' stamp: 'EL 7/1/2008 16:18'!
startUp
	! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 7/10/2008 23:25'!
validateSettingsForConnect
	self settings validatePort.! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 7/10/2008 23:25'!
validateSettingsForOpen
	self settings method.! !

Object subclass: #DBXConnectionSettings
	instanceVariableNames: 'host port database userName userPassword method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:13'!
host: aHost port: aPort
	^ self basicNew
		initializeHost: aHost 
			port: aPort;
		yourself! !

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:31'!
host: aHost port: aPort database: aDatabase userName: aUsername userPassword: aPassword
	^ self basicNew
		initializeHost: aHost 
			port: aPort 
			database: aDatabase 
			userName: aUsername  
			userPassword: aPassword;
		yourself! !

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:32'!
host: aDatabase userName: aUsername userPassword: aPassword
	^ self basicNew
		initializeHost: aDatabase 
			userName: aUsername  
			userPassword: aPassword
		yourself! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
database
	^ database! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
database: anObject
	database := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 6/10/2008 00:50'!
host
	^ host! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
host: anObject
	host := anObject! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:11'!
initializeHost: aHost port: aPort
	self initialize.
	host := aHost.
	port := aPort! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:12'!
initializeHost: aHost port: aPort database: aDatabaseName userName: aUserName userPassword: aPassword
	self initialize.
	host := aHost.
	port := aPort.
	database := aDatabaseName.
	userName := aUserName.
	userPassword := aPassword.! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:13'!
initializeHost: aDatabaseName userName: aUserName userPassword: aPassword
	self initialize.
	database  := aDatabaseName.
	userName := aUserName.
	userPassword := aPassword.! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/11/2008 00:24'!
method
	^ method ifNil: [ method := DBXAuthenticationMethod usernamePassword ]! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
method: anObject
	^ method := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 6/10/2008 00:50'!
port
	^ port! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
port: anObject
	port := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
userName
	^ userName! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
userName: anObject
	userName := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
userPassword
	^ userPassword! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
userPassword: anObject
	userPassword := anObject! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'MMP 7/11/2008 00:24'!
validateMethod
	self method notNil ifTrue: 
		[ self method = DBXAuthenticationMethod usernamePassword ifFalse: [ DBXError signal: 'The only supported method is zero' ] ]! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'MMP 7/10/2008 22:59'!
validatePort
	self port notNil
		ifTrue: [(self port isPositiveInteger)
				ifFalse: [DBXError signal: 'The port must be a positive number']]! !

Object subclass: #DBXPlatform
	instanceVariableNames: ''
	classVariableNames: 'DataTypesMap'
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

DBXPlatform subclass: #DBXMySQLPlatform
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXMySQLPlatform methodsFor: 'as yet unclassified' stamp: 'EL 6/27/2008 20:30'!
backend
	^'mysql'! !

!DBXPlatform class methodsFor: 'defaults' stamp: 'EL 8/3/2008 09:04'!
createDataTypesMap
	^Dictionary new
		at: 16r00 put: Boolean; "BOOLEAN"
		at: 16r01 put: Number; "SMALLINT"
		at: 16r02 put: Number; "INTEGER"
		at: 16r03 put: Number; "BIGINT"
		at: 16r07 put: Number; "DECIMAL"
		at: 16r08 put: Number; "REAL"
		at: 16r09 put: Number; "DOUBLE"
		at: 16r0F put: Number; "FLOAT"
		at: 16r10 put: String; "CHAR"
		at: 16r11 put: String; "NCHAR"
		at: 16r12 put: String; "VARCHAR"
		at: 16r13 put: String; "NVARCHAR"
		at: 16r20 put: DBXTypeNotSupported; "CLOB"
		at: 16r21 put: DBXTypeNotSupported; "NCLOB"
		at: 16r22 put: String; "XML"
		at: 16r2F put: DBXTypeNotSupported; "BLOB"
		at: 16r30 put: Time; "TIME"
		at: 16r31 put: Time; "TIMETZ"
		at: 16r32 put: TimeStamp; "TIMESTAMP"
		at: 16r33 put: TimeStamp; "TIMESTAMPTZ"
		at: 16r34 put: Date; "DATE"
		at: 16r35 put: DBXTypeNotSupported; "INTERVAL"
		at: 16r40 put: DBXTypeNotSupported; "ARRAY"
		at: 16r41 put: DBXTypeNotSupported; "MULTISET"
		at: 16r50 put: DBXTypeNotSupported; "DATALINK"
		at: 16rFF put: DBXTypeNotSupported; "UNKNOWN"
		yourself
! !

!DBXPlatform class methodsFor: 'accessing' stamp: 'EL 8/3/2008 08:49'!
dataTypeAt: aNumber
	^self dataTypesMap at: aNumber! !

!DBXPlatform class methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:58'!
dataTypesMap
	^DataTypesMap ifNil: [ DataTypesMap := self createDataTypesMap ]! !

!DBXPlatform class methodsFor: 'as yet unclassified' stamp: 'EL 8/3/2008 08:53'!
isLarge: aNumber
	"Answer true if aNumber represents a large data object (BLOB, CLOB, NCLOB)"
	^#(16r20 16r21 16r2F) includes: aNumber! !

!DBXPlatform methodsFor: 'accessing' stamp: 'EL 6/27/2008 20:30'!
backend
	^self subclassResponsibility! !

!DBXPlatform methodsFor: 'connection' stamp: 'EL 7/1/2008 20:53'!
closeConnection: aConnection
	| err |
	err := OpenDBX apiUnbind: aConnection handle.
	self verifyError: err on: aConnection.
! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 7/10/2008 00:21'!
createConnection: aConnection 
	| err handleArray handle |
	handleArray := WordArray with: 0.
	err := OpenDBX
				apiInitialize: handleArray
				backend: self backend
				host: aConnection settings host
				port: aConnection settings port.
	handle := handleArray at: 1.
	self verifyError: err handle: handle.
	^ handle! !

!DBXPlatform methodsFor: 'private' stamp: 'EL 8/3/2008 08:50'!
descriptionForColumn: anIndex handle: aHandle on: aConnection
	"anIndex is Zero based"
	| columnName dbxType |
	columnName := OpenDBX apiQueryColumnName: aHandle index: anIndex.
	dbxType := OpenDBX apiQueryColumnType: aHandle index: anIndex. 
	^DBXColumnDescription 
		name: columnName
		dbxType: dbxType
		type: (self class dataTypeAt: dbxType).
! !

!DBXPlatform methodsFor: 'private' stamp: 'EL 6/29/2008 13:04'!
descriptionForResult: aHandle on: aConnection
	| rowsAffected |

	rowsAffected := OpenDBX apiQueryRowsAffected: aHandle.
	self  verifyError: rowsAffected on: aConnection. 
	^DBXResultDescription new
		rowsAffected: rowsAffected;
		yourself.
! !

!DBXPlatform methodsFor: 'private' stamp: 'EL 6/29/2008 13:04'!
descriptionForResultSet: aHandle on: aConnection
	| description columnCount |

	columnCount := OpenDBX apiQueryColumns: aHandle.
	self verifyError: columnCount on: aConnection.  
	description := DBXResultSetDescription new.
	(0 to: (columnCount - 1)) 
		do: [ :i| 
			description addColumnDescription: 
				(self descriptionForColumn: i 
					handle: aHandle 
					on: aConnection) ].
	
	^description! !

!DBXPlatform methodsFor: 'private' stamp: 'HMC 8/4/2008 19:07'!
endDBXResult: aConnection 
	| err handleArray timeout |
	handleArray := WordArray with: 0.
	timeout := DBXTimeSpec seconds: 3.
	[err := OpenDBX
				apiQueryResult: aConnection handle
				handle: handleArray
				timeout: timeout
				chunk: 0]
		doWhileFalse: [err = OpenDBX resultDone ]! !

!DBXPlatform methodsFor: 'error handling' stamp: 'EL 6/30/2008 08:36'!
errorCode: err handle: aHandle
	DBXError signal: (OpenDBX apiError: aHandle number: err)
	
! !

!DBXPlatform methodsFor: 'error handling' stamp: 'MMP 7/2/2008 01:26'!
errorCode: err on: aConnection
	self errorCode: err handle: aConnection handle. 

	
! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 7/18/2008 19:14'!
executeStatement: aString on: aConnection 
	"Executes a query. Answers a handle to the resultSet"
	| err description |
	err := OpenDBX
				apiQuery: aConnection handle
				query: aString
				length: aString size.
	self verifyError: err on: aConnection.
	self
		nextResultSet: aConnection
		onReturn: [:handle :code | 
			code = OpenDBX resultWithoutRows
				ifTrue: [description := self descriptionForResult: handle on: aConnection.
					self endDBXResult: aConnection.
					^ DBXResult
						on: aConnection
						handle: handle
						description: description].
			code = OpenDBX resultWithRows
				ifTrue: [description := self descriptionForResultSet: handle on: aConnection.
					^ DBXResultSet
						on: aConnection
						handle: handle
						description: description]]! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'EL 6/29/2008 12:19'!
fieldRawValue: anIndex on: aResultSet
	^OpenDBX apiQueryFieldValue: (aResultSet handle) index: (anIndex - 1)! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 7/12/2008 01:44'!
getOption: anOption on: aConnection 
	| err isSupported |
	isSupported := WordArray with: 0.
	err := OpenDBX
				apiGetOption: aConnection handle
				option: anOption
				value: isSupported.
	self verifyError: err on: aConnection.
	^ self
		smallIntegerAsBoolean: (isSupported at: 1)! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'EL 8/3/2008 08:56'!
largeFieldRawValue: anIndex on: aResultSet
	| handle |
	OpenDBX apiQueryFieldValue: (aResultSet handle) index: (anIndex - 1)! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'EL 6/29/2008 11:26'!
moveNext: aResultSet
	| err |
	err := OpenDBX apiQueryFetchRow: aResultSet handle.
	self verifyError: err on: aResultSet connection.
	(err = OpenDBX rowDone) 
		ifTrue:[ 
			(self restartResultSet: aResultSet)
				ifTrue: [ ^self moveNext: aResultSet ]
				ifFalse: [ ^nil ] ]
		ifFalse: [ ^DBXRow on: aResultSet ].
	! !

!DBXPlatform methodsFor: 'private' stamp: 'EL 6/29/2008 13:18'!
nextResultSet: aConnection ifDone: aBlock 
	^self nextResultSet: aConnection onReturn: [ :handle :code | 
		(code = OpenDBX resultDone) ifTrue: [ aBlock value ] ] ! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 7/9/2008 01:06'!
nextResultSet: aConnection onReturn: aBlock 
	| handle err handleArray timeout |
	handleArray := WordArray with: 0.
	timeout := DBXTimeSpec seconds: 3.
	err := OpenDBX
				apiQueryResult: aConnection handle
				handle: handleArray
				timeout: timeout
				chunk: 0.
	[self verifyError: err on: aConnection.]
		on: DBXError 
		do: [:e | 
			self endDBXResult: aConnection.
						 e signal].
	handle := handleArray at: 1.
	aBlock notNil
		ifTrue: [aBlock value: handle value: err].
	^ handle! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 7/10/2008 22:03'!
openConnection: aConnection 
	| err |
	err := OpenDBX
				apiBind: aConnection handle
				database: aConnection settings database
				name: aConnection settings userName
				password: aConnection settings userPassword
				method: aConnection settings method.
	self verifyError: err on: aConnection.
	^ true! !

!DBXPlatform methodsFor: 'connection' stamp: 'EL 7/1/2008 20:54'!
releaseConnection: aConnection
	| err |
	err := OpenDBX apiFinalize: aConnection handle.
	self  verifyError: err on: aConnection.
! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'EL 6/29/2008 10:53'!
releaseResultSet: aResultSet
	| err |
	err := OpenDBX apiQueryFinalize: aResultSet handle.
	self verifyError: err on: aResultSet connection.! !

!DBXPlatform methodsFor: 'private' stamp: 'EL 6/29/2008 12:32'!
restartResultSet: aResultSet
	self releaseResultSet: aResultSet.
	self nextResultSet: aResultSet connection ifDone: [ ^false ].
	^true! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 7/12/2008 01:47'!
setOption: anOption value: anObject on: aConnection 
	| err |
	err := OpenDBX
				apiSetOption: aConnection handle
				option: anOption
				value: (WordArray with: anObject asBit).
	self verifyError: err on: aConnection! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 7/12/2008 01:39'!
smallIntegerAsBoolean: aSmallInteger
	(aSmallInteger = 1) ifTrue: [^true].
	(aSmallInteger = 0) ifTrue: [^false].
	DBXError signal: 'Cannot convert form SmallInteger to Boolean'! !

!DBXPlatform methodsFor: 'error handling' stamp: 'EL 6/30/2008 08:37'!
verifyError: err handle: aHandle
	(err < 0) ifTrue: [ self errorCode: err handle: aHandle]! !

!DBXPlatform methodsFor: 'error handling' stamp: 'MMP 7/2/2008 01:27'!
verifyError: err on: aConnection
	self verifyError: err handle: aConnection handle! !

DBXPlatform subclass: #DBXPostgresPlatform
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXPostgresPlatform class methodsFor: 'as yet unclassified' stamp: 'MMP 6/13/2008 01:25'!
log: message
	Transcript show: message; cr.! !

!DBXPostgresPlatform methodsFor: 'as yet unclassified' stamp: 'EL 6/27/2008 20:30'!
backend
	^'pgsql'! !

!DBXPostgresPlatform methodsFor: 'accessing' stamp: 'MMP 6/13/2008 01:16'!
handle
	^ handle! !

!DBXPostgresPlatform methodsFor: 'accessing' stamp: 'MMP 6/13/2008 01:16'!
handle: anObject
	handle := anObject! !

!DBXPostgresPlatform methodsFor: 'accessing' stamp: 'MMP 6/13/2008 01:23'!
log: message
	self class log: message! !

Object subclass: #DBXResult
	instanceVariableNames: 'connection handle description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXResult class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 12:44'!
new
	self error: 'Use #on:handle:'! !

!DBXResult class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 12:59'!
on: aConnection handle: aNumber description: aDescription
	^(self basicNew)
		initializeConnection: aConnection 
			handle: aNumber
			description: aDescription;
		yourself.! !

!DBXResult methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:46'!
connection
	^ connection! !

!DBXResult methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:46'!
description
	^description! !

!DBXResult methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:46'!
handle
	^handle! !

!DBXResult methodsFor: 'testing' stamp: 'EL 6/29/2008 12:42'!
hasRows
	^false! !

!DBXResult methodsFor: 'initialization' stamp: 'EL 6/29/2008 12:54'!
initializeConnection: aConnection handle: aNumber description: aDescription
	super initialize.
	connection := aConnection.
	handle := aNumber.
	description := aDescription.! !

!DBXResult methodsFor: 'testing' stamp: 'EL 6/29/2008 12:49'!
isOpen
	^false! !

!DBXResult methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:49'!
platform
	^self connection platform! !

!DBXResult methodsFor: 'accessing' stamp: 'MMP 7/18/2008 22:07'!
rowsAffected
	^self description rowsAffected! !

DBXResult subclass: #DBXResultSet
	instanceVariableNames: 'open'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXResultSet methodsFor: 'accessing' stamp: 'EL 6/29/2008 10:48'!
columnCount
	^self description columnCount! !

!DBXResultSet methodsFor: 'accessing' stamp: 'EL 6/27/2008 21:58'!
columnDescriptionAt: anIndex
	^self description columnDescriptionAt: anIndex! !

!DBXResultSet methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 19:16'!
columnDescriptionWithName: aName 
	^ [self columnDescriptions
		detect: [:each | each name = aName]]
		on: Error
		do: [DBXError signal: 'A column with that name was not in select statement']! !

!DBXResultSet methodsFor: 'accessing' stamp: 'EL 6/29/2008 10:48'!
columnDescriptions
	^self description columnDescriptions! !

!DBXResultSet methodsFor: 'finalization' stamp: 'HMC 6/3/2008 18:30'!
finalize
	self isOpen ifTrue: [ self finalizeResultSet ]! !

!DBXResultSet methodsFor: 'finalization' stamp: 'EL 6/29/2008 10:55'!
finalizeResultSet
	self platform releaseResultSet: self.
	self internalBeClosed.! !

!DBXResultSet methodsFor: 'testing' stamp: 'EL 7/26/2008 12:56'!
hasRows
	^self isOpen ! !

!DBXResultSet methodsFor: 'initialization' stamp: 'HMC 7/11/2008 15:45'!
initializeConnection: aConnection handle: aNumber description: aDescription
	super initializeConnection: aConnection 
		handle: aNumber 
		description: aDescription.
	open := ValueHolder new contents: false.
	self internalBeOpen.
	self initializeResultSet.! !

!DBXResultSet methodsFor: 'initialization' stamp: 'EL 6/28/2008 09:01'!
initializeResultSet
	WeakRegistry default add: self. ! !

!DBXResultSet methodsFor: 'private' stamp: 'EL 6/27/2008 09:01'!
internalBeClosed
	open contents: false! !

!DBXResultSet methodsFor: 'private' stamp: 'EL 6/27/2008 09:01'!
internalBeOpen
	open contents: true! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 4/25/2008 01:15'!
isOpen
	^open contents! !

!DBXResultSet methodsFor: 'accessing' stamp: 'HMC 7/11/2008 15:52'!
nextRow
	| row |
	self isOpen ifFalse:  [^nil].
	row := self platform moveNext: self.
	row ifNil: [ self internalBeClosed ].
	^row! !

!DBXResultSet methodsFor: 'enumerating' stamp: 'EL 8/2/2008 12:29'!
rows
	| results |
	results := OrderedCollection new.
	self rowsDo: [ :each| 
		results add: each ].
	^results! !

!DBXResultSet methodsFor: 'enumerating' stamp: 'EL 3/31/2008 09:42'!
rowsDo: aBlock
	| row |
	[ row := self nextRow.
	  row notNil ] 
	whileTrue: [ aBlock value: row ]! !

Object subclass: #DBXResultDescription
	instanceVariableNames: 'rowsAffected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXResultDescription methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:52'!
rowsAffected
	^rowsAffected! !

!DBXResultDescription methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:52'!
rowsAffected: aNumber
	rowsAffected := aNumber ! !

Object subclass: #DBXResultSetDescription
	instanceVariableNames: 'columnDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 20:04'!
addColumnDescription: aColumnDescription
	self columnDescriptions add: aColumnDescription! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 20:29'!
columnCount
	^self columnDescriptions size! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 21:58'!
columnDescriptionAt: anIndex
	^self columnDescriptions at: anIndex! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 20:03'!
columnDescriptions
	^columnDescriptions ! !

!DBXResultSetDescription methodsFor: 'initialization' stamp: 'EL 6/27/2008 20:04'!
initialize
	super initialize.
	columnDescriptions := OrderedCollection new.! !

Object subclass: #DBXRow
	instanceVariableNames: 'resultSet fields rawValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXRow class methodsFor: 'instance creation' stamp: 'EL 3/31/2008 10:21'!
new
	self error: 'Use #onResultSet:'! !

!DBXRow class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 11:27'!
on: aResultSet
	^(self basicNew)
		initializeResultSet: aResultSet;
		yourself.
		! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/27/2008 22:01'!
columnDescriptionAt: anIndex
	^self resultSet columnDescriptionAt: anIndex! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/27/2008 21:59'!
columnDescriptionType: anIndex
	^(self columnDescriptionAt: anIndex) type! !

!DBXRow methodsFor: 'private' stamp: 'EL 8/2/2008 12:37'!
columnIndex: aString
	self resultSet columnDescriptions withIndexDo: [ :each :index |
		each name = aString 
			ifTrue: [ ^index ] ].
	^0
	! !

!DBXRow methodsFor: 'private' stamp: 'EL 8/2/2008 12:34'!
convertValueAt: anIndex
	^(self rawValueAt: anIndex)
		ifNotNilDo: [ :columnValue | 
			(self columnDescriptionType: anIndex) fromDbxString: columnValue ]! !

!DBXRow methodsFor: 'initialization' stamp: 'EL 6/29/2008 12:18'!
initializeResultSet: aResultSet
	super initialize.
	resultSet := aResultSet.
	self initializeRow.
	! !

!DBXRow methodsFor: 'initialization' stamp: 'EL 8/3/2008 09:05'!
initializeRow
	rawValues := Array new: self resultSet columnCount.
	self resultSet columnDescriptions withIndexDo: [ :each :i|
		each isLarge
			ifTrue: [ DBXError signal: 'Large objects not supported yet' ]
			ifFalse: [ rawValues at: i put: (self platform fieldRawValue: i  on: self resultSet) ] ]! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/29/2008 12:19'!
platform
	^self resultSet platform! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 7/26/2008 13:30'!
rawValueAt: anIndex
	^rawValues at: anIndex! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 7/26/2008 13:33'!
rawValueNamed: aString
	^self rawValueAt: (self columnIndexNamed: aString) ! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 6/27/2008 21:54'!
rawValues
	^rawValues! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 6/27/2008 21:54'!
rawValuesDo: aBlock
	^self rawValues do: aBlock! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 3/31/2008 10:22'!
resultSet
	^ resultSet! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 8/2/2008 11:52'!
valueAt: anIndex
	^self convertValueAt: anIndex 
! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 8/2/2008 12:37'!
valueNamed: aString
	^self convertValueAt: (self columnIndex: aString).
! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 8/2/2008 12:06'!
values
	^self rawValues withIndexCollect: [ :each :index | 
		each ifNotNil: [
			(self columnDescriptionType: index) fromDbxString: each ] ]! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 6/27/2008 21:59'!
valuesDo: aBlock
	^self values do: aBlock! !

Object subclass: #DBXSpecialOptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
compression
	"0x0022 in hexadecimal in openDBX. But we need it as decimal"
	^16r0022! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
encryption
	 "0x0010 in hexadecimal in openDBX. But we need it as decimal"
	^16r0010! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
multipleStatements
	 "0x0020 in hexadecimal in openDBX. But we need it as decimal"
	^16r0020! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
pagedResults
 	"0x0021 in hexadecimal in openDBX. But we need it as decimal"
	^16r0021! !

Object subclass: #DBXTranscript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 7/18/2008 22:24'!
show: result
	result class = DBXResult
		ifTrue: [self showResult: result].
	result class = DBXResultSet
		ifTrue: [self showResultSet: result]! !

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 7/18/2008 22:25'!
showResult: result 
	Transcript show: 'They were affected ' , result rowsAffected asString, ' rows';
		 cr! !

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 7/18/2008 22:15'!
showResultSet: resultSet 
	| stream |
	stream := String new writeStream.
	resultSet columnDescriptions
		do: [:each | stream nextPutAll: each name]
		separatedBy: [stream nextPutAll: ' | '].
	Transcript show: stream contents;
		 cr.
	resultSet
		rowsDo: [:row | 
			stream := String new writeStream.
			row values
				do: [:each | stream nextPutAll: each asString]
				separatedBy: [stream nextPutAll: ' | '].
			Transcript show: stream contents;
				 cr]! !

Object subclass: #DBXTypeNotSupported
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXTypeNotSupported commentStamp: 'EL 8/3/2008 08:33' prior: 0!
I'm an unsupported data type

Instance Variables
!

!DBXTypeNotSupported class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:34'!
fromDbxString: aString
	^self new
		value: aString;
		yourself! !

!DBXTypeNotSupported methodsFor: 'printing' stamp: 'EL 8/3/2008 08:35'!
printOn: aStream
	aStream 
		nextPutAll: 'NOTSUPPORTED:';
		nextPutAll: self value;
		yourself! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/3/2008 08:34'!
value
	^value! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/3/2008 08:34'!
value: aString
	value := aString! !

!Object class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:09'!
fromDbxString: aString
	self subclassResponsibility! !

!Object methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:18'!
asDbxString
	^ self printString! !

Object subclass: #OpenDBX
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:46'!
apiBind: handle database: databaseName name: userName password: password method: method
	"int odbx_bind(odbx_t* handle, const char* database, const char* who, const char* cred,int method )"
	<cdecl: long 'odbx_bind' (ulong char* char* char* ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'EL 3/29/2008 19:00'!
apiError: handle number: err
	"long odbx_error(odbx_t*)"
	<cdecl: char* 'odbx_error' (ulong long) module: 'opendbx' >
	^self externalCallFailed	! !

!OpenDBX class methodsFor: 'api calls' stamp: 'EL 3/29/2008 18:43'!
apiFinalize: handle 
	"long odbx_finish(odbx_t*)"
	<cdecl: long 'odbx_finish' (ulong) module: 'opendbx' >
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:47'!
apiGetOption: handle option: anOption value: aValue
	"int odbx_get_option(odbx_t* handle, unsigned int option,void* value)"
	<cdecl: long 'odbx_get_option' (ulong ulong void*) module: 'opendbx' >
	^self externalCallFailed
	
! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 4/22/2008 00:39'!
apiInitialize: handle backend: backend host: host port: port
	"long odbx_init(odbx_t**, char*, char*, char*)"
	<cdecl: long 'odbx_init' (ulong* char* char* char*) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'EL 8/3/2008 09:02'!
apiOpenLarge: aResultSetHandleNumber handle: aLargeHandleWordArray value: aString
	"int odbx_lo_open(odbx_result_t* result, odbx_lo_t** lo, const char* value)"
	<cdecl: long 'odbx_lo_open' (ulong ulong* char*) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'EL 3/29/2008 19:13'!
apiQuery: handle query: query length: length
	"long odbx_query(odbx_t*, char*, ulong)"
	<cdecl: long 'odbx_query' (ulong char* ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:48'!
apiQueryColumnLength: handle index: index
	"unsigned long odbx_field_length( odbx_result_t* result, unsigned long pos ) "
	"IMPORTANT: Index es zero-based"
	<cdecl: long 'odbx_field_length' (ulong ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:49'!
apiQueryColumnName: handle index: index
	"char* odbx_column_name(odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<cdecl: char* 'odbx_column_name' (ulong short) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:50'!
apiQueryColumnType: handle index: index
	"char* odbx_column_type( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<cdecl: short 'odbx_column_type' (ulong short) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:50'!
apiQueryColumns: handle
	"int odbx_column_count(odbx_result_t* result )"
	<cdecl: long 'odbx_column_count' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:51'!
apiQueryFetchRow: handle 
	"int odbx_row_fetch( odbx_result_t* result )"
	<cdecl: long 'odbx_row_fetch' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:52'!
apiQueryFieldValue: handle index: index
	"const char* odbx_field_value( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	<cdecl: char* 'odbx_field_value' (ulong ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:52'!
apiQueryFinalize: handle
	"int odbx_result_finish( odbx_result_t* result )"
	<cdecl: long 'odbx_result_finish' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:53'!
apiQueryResult: connectionHandle handle: handle timeout: timeout chunk: chunk
	"int odbx_result( odbx_t* handle, odbx_result_t** result, struct timeval* timeout, unsigned long chunk )"
	<cdecl: long 'odbx_result' (ulong ulong* DBXTimeSpec long) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:53'!
apiQueryRowsAffected: handle
	"uint64_t odbx_rows_affected(odbx_result_t* result )"
	<cdecl: long 'odbx_rows_affected' (ulong) module: 'opendbx'>
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/9/2008 02:54'!
apiSetOption: handle option: anOption value: aValue
	"int odbx_set_option(odbx_t* handle, unsigned int option, void* value ) "
	<cdecl: long 'odbx_set_option' (ulong ulong void*) module: 'opendbx' >
	^self externalCallFailed
	
! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 4/18/2008 01:51'!
apiUnbind: handle 
	"int odbx_unbind(odbx_t*)"
	<cdecl: long 'odbx_unbind' (ulong) module: 'opendbx' >
	^self externalCallFailed! !

!OpenDBX class methodsFor: 'api calls' stamp: 'MMP 7/12/2008 03:04'!
currentOpenDBXVersion
	^'1.3.7'! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 11:19'!
resultDone
	"ODBX_RES_DONE"
	^0! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:20'!
resultTimeout
	^1! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:21'!
resultWithRows
	^3! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:20'!
resultWithoutRows
	^2! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/28/2008 09:11'!
rowDone
	"ODBX_ROW_DONE"
	^0! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/28/2008 09:10'!
rowNext
	"ODBX_ROW_NEXT"
	^1! !

!True methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:55'!
asDbxString
	^'1'! !

!Number class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:10'!
fromDbxString: aString
	^self readFrom: aString readStream! !

!Date class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:36'!
fromDbxString: aString 
	^ self readDbxFrom: aString readStream! !

!Date class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:09'!
readDbxFrom: aStream
	| year month day |

	year := (aStream upTo: $-) asInteger.
	month := (aStream upTo: $-) asInteger.
	day := (aStream upToEnd) asInteger.

	^self year: year 
		month: month 
		day: day! !

!Date methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:27'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents asDbxString ! !

!Date methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:27'!
printDbxOn: aStream
	aStream
		nextPutAll: self year asString;
		nextPut: $-;
		nextPutAll: (self monthIndex asString padded: #left to: 2 with: $0);
		nextPut: $-;
		nextPutAll: (self dayOfMonth asString padded: #left to: 2 with: $0).! !

!UndefinedObject methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 12:49'!
asDbxString
	^'NULL'! !

!Boolean class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:55'!
fromDbxString: aString
	aString = '1' ifTrue: [ ^true ].
	aString = '0' ifTrue: [ ^false ].
	DBXError signal: 'Invalid boolean input: ', aString! !

Error subclass: #DBXError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!
DBXConnection initialize!
